package com.knecon.fforesight.service.layoutparser.processor.model.graph.nodes;

import java.awt.geom.Rectangle2D;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.knecon.fforesight.service.layoutparser.internal.api.data.redaction.LayoutEngine;
import com.knecon.fforesight.service.layoutparser.internal.api.data.redaction.NodeType;
import com.knecon.fforesight.service.layoutparser.processor.model.graph.DocumentTree;
import com.knecon.fforesight.service.layoutparser.processor.model.graph.entity.RedactionEntity;
import com.knecon.fforesight.service.layoutparser.processor.model.graph.textblock.TextBlock;

import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.FieldDefaults;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE)
public class Header implements GenericSemanticNode {

    @Builder.Default
    Set<LayoutEngine> engines = new HashSet<>(Set.of(LayoutEngine.ALGORITHM));
    List<Integer> treeId;
    TextBlock leafTextBlock;

    @EqualsAndHashCode.Exclude
    DocumentTree documentTree;

    @Builder.Default
    @EqualsAndHashCode.Exclude
    Set<RedactionEntity> entities = new HashSet<>();

    @EqualsAndHashCode.Exclude
    Map<Page, Rectangle2D> bBoxCache;


    @Override
    public boolean isLeaf() {

        return true;
    }


    @Override
    public NodeType getType() {

        return NodeType.HEADER;
    }


    @Override
    public TextBlock getTextBlock() {

        return leafTextBlock;
    }


    @Override
    public String toString() {

        return treeId + ": " + NodeType.HEADER + ": " + leafTextBlock.buildSummary();
    }


    @Override
    public Map<Page, Rectangle2D> getBBox() {

        if (bBoxCache == null) {
            bBoxCache = GenericSemanticNode.super.getBBox();
        }
        return bBoxCache;
    }

}
